﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("C48EE8BD-BDDB-47BB-91D1-EBC181B61D0F"), ProgIdAttribute("adx_ol_vb_replyEvent.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents
    Private itemEvents As OutlookItemEvents

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        '
        'adxOutlookEvents
        '
        '
        'AddinModule
        '
        Me.AddinName = "adx_ol_vb_replyEvent"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub ConnectToSelectedItem(ByVal selection As Outlook.Selection)
        If selection IsNot Nothing Then
            If selection.Count = 1 Then
                Dim item As Object = selection.Item(1)
                If TypeOf item Is Outlook.MailItem Then
                    If itemEvents.IsConnected Then
                        itemEvents.RemoveConnection()
                    End If
                    itemEvents.ConnectTo(item, True)
                Else
                    Marshal.ReleaseComObject(item)
                End If
            End If
        End If
    End Sub

    Private Sub AddinModule_AddinStartupComplete(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinStartupComplete
        itemEvents = New OutlookItemEvents(Me)
    End Sub

    Private Sub adxOutlookEvents_ExplorerActivate(sender As System.Object, explorer As System.Object) Handles adxOutlookEvents.ExplorerActivate
        Dim theExplorer As Outlook.Explorer = TryCast(explorer, Outlook.Explorer)
        If theExplorer IsNot Nothing Then
            Dim selection As Outlook.Selection = Nothing
            Try
                selection = theExplorer.Selection
            Catch
            End Try

            If selection IsNot Nothing Then
                ConnectToSelectedItem(selection)
                Marshal.ReleaseComObject(selection)
            End If

        End If
    End Sub

    Private Sub adxOutlookEvents_ExplorerSelectionChange(sender As System.Object, explorer As System.Object) Handles adxOutlookEvents.ExplorerSelectionChange
        Dim theExplorer As Outlook.Explorer = TryCast(explorer, Outlook.Explorer)
        If theExplorer IsNot Nothing Then
            Dim selection As Outlook.Selection = Nothing
            Try
                selection = theExplorer.Selection
            Catch
            End Try

            If selection IsNot Nothing Then
                ConnectToSelectedItem(selection)
                Marshal.ReleaseComObject(selection)
            End If
        End If
    End Sub

    Private Sub AddinModule_AddinBeginShutdown(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinBeginShutdown
        ' this event may not occur in Outlook 2010, see the blog post 'Outlook 2010 Fast Shutdown feature'
        ' at http://www.add-in-express.com/creating-addins-blog/2010/05/04/outlook2010-fast-shutdown/

        If itemEvents.IsConnected Then
            itemEvents.RemoveConnection()
        End If
        itemEvents = Nothing
    End Sub

End Class

